/*
 * ToGrammar.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ToGrammar.h"
#include "ToGrammarRightRG.h"

namespace automaton {

namespace convert {

grammar::Grammar ToGrammar::convert(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

grammar::Grammar ToGrammar::convert(const automaton::NFA& automaton) {
	return grammar::Grammar(ToGrammarRightRG::convert(automaton));
}

auto ToGrammarNFA = ToGrammar::RegistratorWrapper<grammar::Grammar, automaton::NFA>(ToGrammar::convert);

grammar::Grammar ToGrammar::convert(const automaton::DFA& automaton) {
	return grammar::Grammar(ToGrammarRightRG::convert(automaton));
}

auto ToGrammarDFA = ToGrammar::RegistratorWrapper<grammar::Grammar, automaton::DFA>(ToGrammar::convert);

} /* namespace convert */

} /* namespace automaton */
