/*
 * Run.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _AUTOMATON_RUN_H__
#define _AUTOMATON_RUN_H__

#include <core/multipleDispatch.hpp>
#include <automaton/AutomatonFeatures.h>
#include <string/LinearString.h>
#include <tree/ranked/RankedTree.h>
#include <alphabet/Symbol.h>

namespace automaton {

namespace run {

class Run {
	static std::pair < bool, State > calculateState ( const automaton::DFTA & automaton, const tree::RankedNode & node, std::set < unsigned > & occ, unsigned & i );
	static std::pair < bool, std::set < State > > calculateStates ( const automaton::NFTA & automaton, const tree::RankedNode & node, std::set < unsigned > & occ, unsigned & i );
	static bool canPop ( const std::deque < alphabet::Symbol > & pushdownStore, const std::vector < alphabet::Symbol > & pop );

public:
	static std::tuple < bool, State, std::set < unsigned > > calculateState ( const automaton::DFA & automaton, const string::LinearString & string );
	static std::tuple < bool, std::set < State >, std::set < unsigned > > calculateStates ( const automaton::NFA & automaton, const string::LinearString & string );
	static std::tuple < bool, State, std::set < unsigned > > calculateState ( const automaton::DFTA & automaton, const tree::RankedTree & tree );
	static std::tuple < bool, std::set < State >, std::set < unsigned > > calculateStates ( const automaton::NFTA & automaton, const tree::RankedTree & tree );
	static std::tuple < bool, State, std::set < unsigned >, std::deque < alphabet::Symbol > > calculateState ( const automaton::InputDrivenDPDA & automaton, const string::LinearString & string );
	static std::tuple < bool, State, std::set < unsigned >, std::deque < alphabet::Symbol > > calculateState ( const automaton::VisiblyPushdownDPDA & automaton, const string::LinearString & string );
	static std::tuple < bool, State, std::set < unsigned >, std::deque < alphabet::Symbol > > calculateState ( const automaton::RealTimeHeightDeterministicDPDA & automaton, const string::LinearString & string );
	static std::tuple < bool, State, std::set < unsigned >, std::deque < alphabet::Symbol > > calculateState ( const automaton::DPDA & automaton, const string::LinearString & string );
	static std::tuple < bool, std::set < State >, std::set < std::vector < alphabet::Symbol > > > calculateStates ( const automaton::NPDTA & automaton, const string::LinearString & string );
};

} /* namespace run */

} /* namespace automaton */

#endif /* _AUTOMATON_RUN_H__ */
