/*
 * UnreachableSymbols.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef UNREACHABLE_SYMBOLS_H_
#define UNREACHABLE_SYMBOLS_H_

#include <core/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <alphabet/Symbol.h>

namespace grammar {

namespace properties {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class UnreachableSymbols : public std::SingleDispatch<UnreachableSymbols, std::set<alphabet::Symbol>, grammar::GrammarBase> {
public:
	static std::set<alphabet::Symbol> getUnreachableSymbols( const grammar::Grammar & grammar );

	/**
	 * Implements
	 */
	template<class T>
	static std::set<alphabet::Symbol> getUnreachableSymbols( const T & grammar );
};

} /* namespace properties */

} /* namespace grammar */

#endif /* UNREACHABLE_SYMBOLS_H_ */
