/*
 * FordFulkerson.h
 *
 *   Created on: Mar 29, 2016
 *       Author: Jan Broz
 */

#ifndef GRAPH_FORD_FULKERSON_CUT
#define MIN_CUT_BASIC

#include <unordered_set>

#include <core/multipleDispatch.hpp>
#include <graph/GraphClasses.h>


namespace std {
	template<>
	struct hash< std::pair< graph::Node, graph::Node > > {
		std::size_t operator()( const std::pair< graph::Node, graph::Node > & p ) const {
			return std::hash<std::string>()( static_cast<std::string>(p.first) + static_cast<std::string>(p.second) );
		}
	};
}


namespace graph {

namespace minimumcut {

typedef std::unordered_set< std::pair< Node, Node > > Cut;

class FordFulkerson : public std::SingleDispatch2LastStaticParams< FordFulkerson, Cut, graph::GraphBase, Node, Node > {

 public:

	static Cut fordfulkerson( const Graph & graph, Node source, Node sink );

	static Cut fordfulkerson( const DirectedGraph & graph, Node source, Node sink );

	static Cut fordfulkerson( const UndirectedGraph & graph, Node source, Node sink );

};

} // namespace minimumcut

} // namespace graph


#endif // MIN_CUT_BASIC
