/*
 * RegExpToAutomaton.h
 *
 *  Created on: 11. 1. 2014
 *	  Author: Tomas Pecka
 */

#ifndef REG_EXP_TO_AUTOMATON_H_
#define REG_EXP_TO_AUTOMATON_H_

#include <core/multipleDispatch.hpp>

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

#include <automaton/Automaton.h>

namespace regexp {

namespace convert {

class ToAutomaton : public std::SingleDispatch<ToAutomaton, automaton::Automaton, regexp::RegExpBase> {
public:
	/**
	 * Performs conversion.
	 * @return FSM equivalent to original regular expression.
	 */
	static automaton::Automaton convert(const regexp::RegExp& regexp);

	static automaton::Automaton convert(const regexp::FormalRegExp& regexp);
	static automaton::Automaton convert(const regexp::UnboundedRegExp& regexp);

};

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_AUTOMATON_H_ */
