/*
 * Author: Radovan Cerveny
 */

#ifndef FACTOR_ORACLE_AUTOMATON_H__
#define FACTOR_ORACLE_AUTOMATON_H__

#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>
#include <string/LinearString.h>
#include <string/String.h>
#include <core/multipleDispatch.hpp>

namespace stringology {

namespace exact {

class FactorOracleAutomaton : public std::SingleDispatch < FactorOracleAutomaton, automaton::Automaton, string::StringBase > {
private:
    static void oracleAddLetter ( automaton::DFA & oracle, const alphabet::Symbol & symbol, std::map < automaton::State, automaton::State > & supplyFunction );

public:
    /**
     * Constructs factor oracle automaton for given pattern.
     * @return factor oracle automaton for given pattern
     */
    static automaton::Automaton construct ( const string::String & pattern );

    static automaton::DFA construct ( const string::LinearString & pattern );

};

} /* namespace exact */

} /* namespace stringology */

#endif /* FACTOR_ORACLE_AUTOMATON_H__ */
