#ifndef LR_PARSER_TEST_H_
#define LR_PARSER_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class LRParser : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( LRParser );
	CPPUNIT_TEST ( testEndOfInputSymbol );
	CPPUNIT_TEST ( testParseCorrectInput );
	CPPUNIT_TEST ( testParseIncorrectInput );
	CPPUNIT_TEST_SUITE_END ( );

	alphabet::Symbol E = alphabet::symbolFrom ( 'E' );
	alphabet::Symbol T = alphabet::symbolFrom ( 'T' );
	alphabet::Symbol F = alphabet::symbolFrom ( 'F' );

	alphabet::Symbol plus = alphabet::symbolFrom ( '+' );
	alphabet::Symbol times = alphabet::symbolFrom ( '*' );
	alphabet::Symbol leftParenthesis = alphabet::symbolFrom ( '(' );
	alphabet::Symbol rightParenthesis = alphabet::symbolFrom ( ')' );
	alphabet::Symbol identifier = alphabet::symbolFrom ( "id" );
	
	grammar::CFG getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testEndOfInputSymbol ( );
	void testParseCorrectInput ( );
	void testParseIncorrectInput ( );
};

#endif /* LR_PARSER_TEST_H_ */
