#include "IsomorphismTest.h"

#include "graph/isomorphism/Isomorphism.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(GraphIsomorphismTest, "graph");
CPPUNIT_TEST_SUITE_REGISTRATION(GraphIsomorphismTest);

// !!todo!! fix graph::isomorphism::hopcroft::Graph::init

void GraphIsomorphismTest::testSameGraphs()
{
/*
	graph::Node n1("n1");
	graph::Node n2("n2");
	graph::Node n3("n3");
	graph::Node n4("n4");
	graph::Node n5("n5");

	// Undirected
	graph::AdjacencyListUndirectedGraph ug1;
	ug1.addNode(n1);
	ug1.addNode(n2);
	ug1.addNode(n3);
	ug1.addNode(n4);
	ug1.addNode(n5);
	ug1.addEdge(graph::UndirectedEdge(n1, n2));
	ug1.addEdge(graph::UndirectedEdge(n1, n3));
	ug1.addEdge(graph::UndirectedEdge(n1, n4));
	ug1.addEdge(graph::UndirectedEdge(n2, n3));
	ug1.addEdge(graph::UndirectedEdge(n3, n4));
	ug1.addEdge(graph::UndirectedEdge(n5, n4));
	ug1.addEdge(graph::UndirectedEdge(n5, n3));
	ug1.addEdge(graph::UndirectedEdge(n5, n2));

	graph::AdjacencyListUndirectedGraph ug2;
	ug2.addNode(n1);
	ug2.addNode(n2);
	ug2.addNode(n3);
	ug2.addNode(n4);
	ug2.addNode(n5);
	ug2.addEdge(graph::UndirectedEdge(n1, n2));
	ug2.addEdge(graph::UndirectedEdge(n1, n2, "multi-edge1"));
	ug2.addEdge(graph::UndirectedEdge(n1, n2, "multi-edge2"));
	ug2.addEdge(graph::UndirectedEdge(n1, n2, "multi-edge3"));
	ug2.addEdge(graph::UndirectedEdge(n1, n3));
	ug2.addEdge(graph::UndirectedEdge(n1, n4));
	ug2.addEdge(graph::UndirectedEdge(n1, n4, "multi-edge4"));
	ug2.addEdge(graph::UndirectedEdge(n2, n3));
	ug2.addEdge(graph::UndirectedEdge(n2, n3, "multi-edge5"));
	ug2.addEdge(graph::UndirectedEdge(n3, n4));
	ug2.addEdge(graph::UndirectedEdge(n5, n4));
	ug2.addEdge(graph::UndirectedEdge(n5, n4, "multi-edge6"));
	ug2.addEdge(graph::UndirectedEdge(n5, n3));
	ug2.addEdge(graph::UndirectedEdge(n5, n2));
	ug2.addEdge(graph::UndirectedEdge(n5, n5, "loop1"));
	ug2.addEdge(graph::UndirectedEdge(n5, n5, "loop2"));

	// Same simple graphs
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(ug1, ug1));

	// Same graphs with multi-edges and loops
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(ug2, ug2));

	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(ug1, ug2));
	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(ug2, ug1));

	// Directed
	graph::AdjacencyListDirectedGraph dg1;
	dg1.addNode(n1);
	dg1.addNode(n2);
	dg1.addNode(n3);
	dg1.addNode(n4);
	dg1.addNode(n5);
	dg1.addEdge(graph::DirectedEdge(n1, n2));
	dg1.addEdge(graph::DirectedEdge(n1, n3));
	dg1.addEdge(graph::DirectedEdge(n1, n4));
	dg1.addEdge(graph::DirectedEdge(n2, n3));
	dg1.addEdge(graph::DirectedEdge(n3, n4));
	dg1.addEdge(graph::DirectedEdge(n5, n4));
	dg1.addEdge(graph::DirectedEdge(n5, n3));
	dg1.addEdge(graph::DirectedEdge(n5, n2));

	graph::AdjacencyListDirectedGraph dg2;
	dg2.addNode(n1);
	dg2.addNode(n2);
	dg2.addNode(n3);
	dg2.addNode(n4);
	dg2.addNode(n5);
	dg2.addEdge(graph::DirectedEdge(n1, n2));
	dg2.addEdge(graph::DirectedEdge(n1, n2, "multi-edge1"));
	dg2.addEdge(graph::DirectedEdge(n1, n2, "multi-edge2"));
	dg2.addEdge(graph::DirectedEdge(n1, n2, "multi-edge3"));
	dg2.addEdge(graph::DirectedEdge(n1, n3));
	dg2.addEdge(graph::DirectedEdge(n1, n4));
	dg2.addEdge(graph::DirectedEdge(n1, n4, "multi-edge4"));
	dg2.addEdge(graph::DirectedEdge(n2, n3));
	dg2.addEdge(graph::DirectedEdge(n2, n3, "multi-edge5"));
	dg2.addEdge(graph::DirectedEdge(n3, n4));
	dg2.addEdge(graph::DirectedEdge(n5, n4));
	dg2.addEdge(graph::DirectedEdge(n5, n4, "multi-edge6"));
	dg2.addEdge(graph::DirectedEdge(n5, n3));
	dg2.addEdge(graph::DirectedEdge(n5, n2));
	dg2.addEdge(graph::DirectedEdge(n5, n5, "loop1"));
	dg2.addEdge(graph::DirectedEdge(n5, n5, "loop2"));

	// Same simple graphs
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(dg1, dg1));

	// Same graphs with multi-edges and loops
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(dg2, dg2));

	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(dg1, dg2));
	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(dg2, dg1));
*/
}

void GraphIsomorphismTest::testIsomorphicGraphs()
{
/*
	graph::Node n1("n1");
	graph::Node n2("n2");
	graph::Node n3("n3");
	graph::Node n4("n4");
	graph::Node n5("n5");

	graph::Node n1_("n1_");
	graph::Node n2_("n2_");
	graph::Node n3_("n3_");
	graph::Node n4_("n4_");
	graph::Node n5_("n5_");

	// Undirected
	graph::AdjacencyListUndirectedGraph ug1;
	ug1.addNode(n1);
	ug1.addNode(n2);
	ug1.addNode(n3);
	ug1.addNode(n4);
	ug1.addNode(n5);
	ug1.addEdge(graph::UndirectedEdge(n1, n2));
	ug1.addEdge(graph::UndirectedEdge(n1, n3));
	ug1.addEdge(graph::UndirectedEdge(n1, n4));
	ug1.addEdge(graph::UndirectedEdge(n2, n3));
	ug1.addEdge(graph::UndirectedEdge(n3, n4));
	ug1.addEdge(graph::UndirectedEdge(n5, n4));
	ug1.addEdge(graph::UndirectedEdge(n5, n3));
	ug1.addEdge(graph::UndirectedEdge(n5, n2));

	graph::AdjacencyListUndirectedGraph ug1_;
	ug1_.addNode(n1_);
	ug1_.addNode(n2_);
	ug1_.addNode(n3_);
	ug1_.addNode(n4_);
	ug1_.addNode(n5_);
	ug1_.addEdge(graph::UndirectedEdge(n2_, n1_));
	ug1_.addEdge(graph::UndirectedEdge(n3_, n2_));
	ug1_.addEdge(graph::UndirectedEdge(n4_, n1_));
	ug1_.addEdge(graph::UndirectedEdge(n5_, n4_));
	ug1_.addEdge(graph::UndirectedEdge(n3_, n5_));
	ug1_.addEdge(graph::UndirectedEdge(n3_, n1_));
	ug1_.addEdge(graph::UndirectedEdge(n5_, n2_));
	ug1_.addEdge(graph::UndirectedEdge(n4_, n3_));

	graph::AdjacencyListUndirectedGraph ug2;
	ug2.addNode(n1);
	ug2.addNode(n2);
	ug2.addNode(n3);
	ug2.addNode(n4);
	ug2.addNode(n5);
	ug2.addEdge(graph::UndirectedEdge(n1, n2));
	ug2.addEdge(graph::UndirectedEdge(n1, n2, "multi-edge1"));
	ug2.addEdge(graph::UndirectedEdge(n1, n2, "multi-edge2"));
	ug2.addEdge(graph::UndirectedEdge(n1, n2, "multi-edge3"));
	ug2.addEdge(graph::UndirectedEdge(n1, n3));
	ug2.addEdge(graph::UndirectedEdge(n1, n4));
	ug2.addEdge(graph::UndirectedEdge(n1, n4, "multi-edge4"));
	ug2.addEdge(graph::UndirectedEdge(n2, n3));
	ug2.addEdge(graph::UndirectedEdge(n2, n3, "multi-edge5"));
	ug2.addEdge(graph::UndirectedEdge(n3, n4));
	ug2.addEdge(graph::UndirectedEdge(n5, n4));
	ug2.addEdge(graph::UndirectedEdge(n5, n4, "multi-edge6"));
	ug2.addEdge(graph::UndirectedEdge(n5, n3));
	ug2.addEdge(graph::UndirectedEdge(n5, n2));
	ug2.addEdge(graph::UndirectedEdge(n5, n5, "loop1"));
	ug2.addEdge(graph::UndirectedEdge(n5, n5, "loop2"));

	graph::AdjacencyListUndirectedGraph ug2_;
	ug2_.addNode(n1_);
	ug2_.addNode(n2_);
	ug2_.addNode(n3_);
	ug2_.addNode(n4_);
	ug2_.addNode(n5_);
	ug2_.addEdge(graph::UndirectedEdge(n1_, n2_));
	ug2_.addEdge(graph::UndirectedEdge(n1_, n2_, "multi-edge1_"));
	ug2_.addEdge(graph::UndirectedEdge(n1_, n2_, "multi-edge2_"));
	ug2_.addEdge(graph::UndirectedEdge(n1_, n2_, "multi-edge3_"));
	ug2_.addEdge(graph::UndirectedEdge(n1_, n3_));
	ug2_.addEdge(graph::UndirectedEdge(n1_, n4_));
	ug2_.addEdge(graph::UndirectedEdge(n1_, n4_, "multi-edge4_"));
	ug2_.addEdge(graph::UndirectedEdge(n2_, n3_));
	ug2_.addEdge(graph::UndirectedEdge(n2_, n3_, "multi-edge5_"));
	ug2_.addEdge(graph::UndirectedEdge(n3_, n4_));
	ug2_.addEdge(graph::UndirectedEdge(n5_, n4_));
	ug2_.addEdge(graph::UndirectedEdge(n5_, n4_, "multi-edge6_"));
	ug2_.addEdge(graph::UndirectedEdge(n5_, n3_));
	ug2_.addEdge(graph::UndirectedEdge(n5_, n2_));
	ug2_.addEdge(graph::UndirectedEdge(n5_, n5_, "loop1_"));
	ug2_.addEdge(graph::UndirectedEdge(n5_, n5_, "loop2_"));

	// Isomorphic simple graphs
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(ug1, ug1_));

	// Isomorphic graphs with multi-edges and loops
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(ug2, ug2_));

	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(ug1, ug2));
	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(ug1, ug2_));

	// Directed
	graph::AdjacencyListDirectedGraph dg1;
	ug1.addNode(n1);
	ug1.addNode(n2);
	ug1.addNode(n3);
	ug1.addNode(n4);
	ug1.addNode(n5);
	dg1.addEdge(graph::DirectedEdge(n1, n2));
	dg1.addEdge(graph::DirectedEdge(n1, n3));
	dg1.addEdge(graph::DirectedEdge(n1, n4));
	dg1.addEdge(graph::DirectedEdge(n2, n3));
	dg1.addEdge(graph::DirectedEdge(n3, n4));
	dg1.addEdge(graph::DirectedEdge(n5, n4));
	dg1.addEdge(graph::DirectedEdge(n5, n3));
	dg1.addEdge(graph::DirectedEdge(n5, n2));

	graph::AdjacencyListDirectedGraph dg1_;
	ug1_.addNode(n1_);
	ug1_.addNode(n2_);
	ug1_.addNode(n3_);
	ug1_.addNode(n4_);
	ug1_.addNode(n5_);
	dg1_.addEdge(graph::DirectedEdge(n5_, n4_));
	dg1_.addEdge(graph::DirectedEdge(n1_, n4_));
	dg1_.addEdge(graph::DirectedEdge(n1_, n3_));
	dg1_.addEdge(graph::DirectedEdge(n5_, n2_));
	dg1_.addEdge(graph::DirectedEdge(n1_, n2_));
	dg1_.addEdge(graph::DirectedEdge(n3_, n4_));
	dg1_.addEdge(graph::DirectedEdge(n2_, n3_));
	dg1_.addEdge(graph::DirectedEdge(n5_, n3_));

	graph::AdjacencyListDirectedGraph dg2;
	ug2.addNode(n1);
	ug2.addNode(n2);
	ug2.addNode(n3);
	ug2.addNode(n4);
	ug2.addNode(n5);
	dg2.addEdge(graph::DirectedEdge(n1, n2));
	dg2.addEdge(graph::DirectedEdge(n1, n2, "multi-edge1"));
	dg2.addEdge(graph::DirectedEdge(n1, n2, "multi-edge2"));
	dg2.addEdge(graph::DirectedEdge(n1, n2, "multi-edge3"));
	dg2.addEdge(graph::DirectedEdge(n1, n3));
	dg2.addEdge(graph::DirectedEdge(n1, n4));
	dg2.addEdge(graph::DirectedEdge(n1, n4, "multi-edge4"));
	dg2.addEdge(graph::DirectedEdge(n2, n3));
	dg2.addEdge(graph::DirectedEdge(n2, n3, "multi-edge5"));
	dg2.addEdge(graph::DirectedEdge(n3, n4));
	dg2.addEdge(graph::DirectedEdge(n5, n4));
	dg2.addEdge(graph::DirectedEdge(n5, n4, "multi-edge6"));
	dg2.addEdge(graph::DirectedEdge(n5, n3));
	dg2.addEdge(graph::DirectedEdge(n5, n2));
	dg2.addEdge(graph::DirectedEdge(n5, n5, "loop1"));
	dg2.addEdge(graph::DirectedEdge(n5, n5, "loop2"));

	graph::AdjacencyListDirectedGraph dg2_;
	ug2_.addNode(n1_);
	ug2_.addNode(n2_);
	ug2_.addNode(n3_);
	ug2_.addNode(n4_);
	ug2_.addNode(n5_);
	dg2_.addEdge(graph::DirectedEdge(n1_, n2_));
	dg2_.addEdge(graph::DirectedEdge(n1_, n2_, "multi-edge3_"));
	dg2_.addEdge(graph::DirectedEdge(n1_, n2_, "multi-edge1_"));
	dg2_.addEdge(graph::DirectedEdge(n1_, n3_));
	dg2_.addEdge(graph::DirectedEdge(n1_, n4_, "multi-edge4_"));
	dg2_.addEdge(graph::DirectedEdge(n1_, n4_));
	dg2_.addEdge(graph::DirectedEdge(n1_, n2_, "multi-edge2_"));
	dg2_.addEdge(graph::DirectedEdge(n5_, n4_));
	dg2_.addEdge(graph::DirectedEdge(n2_, n3_, "multi-edge5_"));
	dg2_.addEdge(graph::DirectedEdge(n3_, n4_));
	dg2_.addEdge(graph::DirectedEdge(n5_, n3_));
	dg2_.addEdge(graph::DirectedEdge(n5_, n5_, "loop1_"));
	dg2_.addEdge(graph::DirectedEdge(n2_, n3_));
	dg2_.addEdge(graph::DirectedEdge(n5_, n2_));
	dg2_.addEdge(graph::DirectedEdge(n5_, n4_, "multi-edge6_"));
	dg2_.addEdge(graph::DirectedEdge(n5_, n5_, "loop2_"));

	// Isomorphic simple graphs
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(dg1, dg1_));

	// Isomorphic graphs with multi-edges and loops
	CPPUNIT_ASSERT_EQUAL(true, graph::isomorphism::Isomorphism::isomorphism(dg2, dg2_));

	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(dg1, dg2));
	CPPUNIT_ASSERT_EQUAL(false, graph::isomorphism::Isomorphism::isomorphism(dg1, dg2_));
*/
}

