/*
 * ObjectBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef OBJECT_BASE_H_
#define OBJECT_BASE_H_

#include <deque>
#include <memory>
#include "../sax/Token.h"
#include "../base/CommonBase.hpp"

namespace alib {

/**
 * Represents generic object.
 */
class ObjectBase : public alib::CommonBase<ObjectBase>, public std::cow_shared_ptr_base {
public:
	virtual void compose(std::deque<sax::Token>& out) const = 0;

	virtual ObjectBase* clone() const = 0;
	virtual ObjectBase* plunder() && = 0;
};

} /* namespace alib */

#endif /* OBJECT_BASE_H_ */

