/*
 * Graph.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_H_
#define GRAPH_H_

#include <base/WrapperBase.hpp>
#include "GraphBase.h"

namespace graph {

 // Wrapper around graphs.
class Graph : public alib::WrapperBase < GraphBase > {
	using alib::WrapperBase < GraphBase >::WrapperBase;

public:
	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "GraphRef";

		return xmlTagName;
	}
};

} // namespace graph

namespace std {

template < >
struct compare < graph::Graph > {
	int operator ()( const graph::Graph & first, const graph::Graph & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} // namespace

#endif // GRAPH_H_
