/*
 * Primitive.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_H_
#define PRIMITIVE_H_

#include <base/WrapperBase.hpp>
#include "PrimitiveBase.h"

namespace primitive {

/**
 * Wrapper around primitive data types.
 */
class Primitive : public alib::WrapperBase < PrimitiveBase > {
	using alib::WrapperBase < PrimitiveBase >::WrapperBase;

public:
	Primitive next ( ) const;
	void inc ( );

	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "PrimitiveRef";

		return xmlTagName;
	}
};

Primitive primitiveFrom ( int number );
Primitive primitiveFrom ( char character );
Primitive primitiveFrom ( std::string string );
Primitive primitiveFrom ( const char * string );
Primitive primitiveFrom ( unsigned number );
Primitive primitiveFrom ( bool value );

} /* namespace primitive */

#endif /* PRIMITIVE_H_ */
