/*
 * UnboundedRegExpElement.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "UnboundedRegExpElement.h"
#include <typeinfo>

#include "UnboundedRegExpElements.h"

#include "../common/RegExpFromXMLParser.h"
#include "../common/RegExpToXMLComposer.h"
#include <exception/CommonException.h>

namespace regexp {

UnboundedRegExpElement::UnboundedRegExpElement ( ) : parentRegExp ( NULL ) {
}

std::set < alphabet::Symbol > UnboundedRegExpElement::computeMinimalAlphabet ( ) const {
	std::set < alphabet::Symbol > res;

	computeMinimalAlphabet ( res );
	return res;
}

} /* namespace regexp */

namespace alib {

std::rvalue_ref < regexp::UnboundedRegExpElement > xmlApi < regexp::UnboundedRegExpElement >::parse ( std::deque < sax::Token >::iterator & input ) {
	return regexp::RegExpFromXMLParser::parseUnboundedRegExpElement ( input );
}

bool xmlApi < regexp::UnboundedRegExpElement >::first ( const std::deque < sax::Token >::const_iterator & ) {
	throw exception::CommonException ( "Unimplemented" );
}

void xmlApi < regexp::UnboundedRegExpElement >::compose ( std::deque < sax::Token > & output, const regexp::UnboundedRegExpElement & data ) {
	data.Accept ( ( void * ) & output, regexp::RegExpToXMLComposer::REGEXP_TO_XML_COMPOSER );
}

} /* namespace alib */
