/*
 * StringBase.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_BASE_H_
#define STRING_BASE_H_

#include <object/ObjectBase.h>
#include <set>
#include "../alphabet/Symbol.h"

namespace string {

/**
 * Represents symbol in an alphabet.
 */
class StringBase : public alib::ObjectBase {
public:
	virtual StringBase * clone ( ) const = 0;
	virtual StringBase * plunder ( ) &&	 = 0;

	virtual const std::set < alphabet::Symbol > & getAlphabet ( ) const = 0;
	virtual void extendAlphabet ( const std::set < alphabet::Symbol > & symbols ) = 0;
};

} /* namespace string */

#endif /* STRING_BASE_H_ */
