/*
 * TreeBase.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Jan Tranicek
 */

#ifndef UNRANKED_TREE_BASE_H_
#define UNRANKED_TREE_BASE_H_

#include "TreeBase.h"
#include <set>
#include "../alphabet/Symbol.h"

namespace tree {

/**
 * Represents symbol in an alphabet.
 */
class UnrankedTreeBase : public TreeBase {
public:
	virtual UnrankedTreeBase * clone ( ) const = 0;
	virtual UnrankedTreeBase * plunder ( ) &&  = 0;

	virtual const std::set < alphabet::Symbol > & getAlphabet ( ) const = 0;
	virtual void extendAlphabet ( const std::set < alphabet::Symbol > & symbols ) = 0;
};

} /* namespace tree */

#endif /* UNRANKED_TREE_BASE_H_ */
