#include <list>
#include "trimTest.h"

#include "automaton/simplify/Trim.h"

#include "automaton/FSM/DFA.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( trimTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( trimTest );

void trimTest::setUp() {
}

void trimTest::tearDown() {
}

void trimTest::testTrimAutomaton() {
  automaton::DFA automaton(automaton::State(1));

  automaton.addState(automaton::State(1));
  automaton.addState(automaton::State(2));
  automaton.addState(automaton::State(3));
  automaton.addInputSymbol(alphabet::symbolFrom("a"));
  automaton.addInputSymbol(alphabet::symbolFrom("b"));
  
  automaton.addTransition(automaton::State(1), alphabet::symbolFrom("a"), automaton::State(2));
  automaton.addTransition(automaton::State(2), alphabet::symbolFrom("b"), automaton::State(1));
  automaton.addTransition(automaton::State(3), alphabet::symbolFrom("b"), automaton::State(1));

  automaton.addFinalState(automaton::State(1));
  
  automaton::DFA trimed = automaton::simplify::Trim::trim(automaton);

  CPPUNIT_ASSERT(trimed.getStates().size() == 2);
}
