/*
 * StringToRawComposer.cpp
 *
 *  Created on: Nov 16, 2014
 *      Author: Jan Travnicek
 */

#include <string/StringClasses.h>
#include "StringToRawComposer.h"

namespace string {

void StringToRawComposer::compose(std::ostream& out, const String& string) {
	dispatch(out, string.getData());
}

void StringToRawComposer::compose(std::ostream& out, const LinearString& string) {
	for(const alphabet::Symbol& symbol : string.getContent()) {
		out << (std::string) symbol;
	}
}

StringToRawComposer::RegistratorWrapper<void, LinearString> StringToRawComposerLinearString = StringToRawComposer::RegistratorWrapper<void, LinearString>(StringToRawComposer::compose);

} /* namespace automaton */

