/*
 * StringToRawComposer.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Jan Travnicek
 */

#ifndef STRING_TO_RAW_COMPOSER_H_
#define STRING_TO_RAW_COMPOSER_H_

#include <deque>
#include <vector>
#include <core/multipleDispatch.hpp>
#include <string/String.h>
#include <string/StringFeatures.h>
#include <alphabet/SymbolFeatures.h>

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToRawComposer : public std::SingleDispatchFirstStaticParam<StringToRawComposer, void, std::ostream&, StringBase> {
public:
	static void compose(std::ostream& out, const String& string);

	static void compose(std::ostream& out, const LinearString& string);

};

} /* namespace string */

#endif /* STRING_TO_RAW_COMPOSER_H_ */

