/*
 * pair.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef __PAIR_HPP_
#define __PAIR_HPP_

namespace std {

template< class T, class R >
std::ostream& operator<<(std::ostream& out, const std::pair<T, R>& pair) {
	out << "(" << pair.first << ", " << pair.second << ")";
	return out;
}

template<class T, class R>
struct compare<pair<T, R>> {
	int operator()(const pair<T, R>& first, const pair<T, R>& second) const {
		compare<typename std::decay < T >::type > compT;
		compare<typename std::decay < R >::type > compR;

		int res = compT(first.first, second.first);
		if(res == 0) res = compR(first.second, second.second);
		return res;
	}
};

} /* namespace std */

#endif /* __PAIR_HPP_ */

