/*
 * StringToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_TO_STRING_COMPOSER_H_
#define STRING_TO_STRING_COMPOSER_H_

#include <ostream>
#include <core/multipleDispatch.hpp>
#include "string/String.h"
#include "string/StringFeatures.h"

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToStringComposer: public std::SingleDispatchFirstStaticParam<StringToStringComposer, void, std::ostream&, StringBase> {
public:
	static void compose(std::ostream&, const LinearString& string);
	static void compose(std::ostream&, const CyclicString& string);
	static void compose(std::ostream&, const Epsilon& string);

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	static void compose(std::ostream& output, const String& string);
};

} /* namespace string */

#endif /* STRING_TO_STRING_COMPOSER_H_ */
